Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.api.score.buildin.hardmediumsoft
Class HardMediumSoftScore

    java.lang.Object
      org.optaplanner.core.api.score.AbstractScore<HardMediumSoftScore>
          org.optaplanner.core.api.score.buildin.hardmediumsoft.HardMediumSoftScore

All Implemented Interfaces:
  Serializable, Comparable<HardMediumSoftScore>, FeasibilityScore<HardMediumSoftScore>, Score<HardMediumSoftScore>

    public final class HardMediumSoftScore

extends AbstractScore<HardMediumSoftScore>
implements FeasibilityScore<HardMediumSoftScore>

This `Score` is based on 3 levels of int constraints: hard, medium and soft. Hard constraints have priority over medium constraints. Medium constraints have priority over soft constraints.

This class is immutable.

See Also:
  `Score`, Serialized Form

Method Summary
`HardMediumSoftScore` | `add(HardMediumSoftScore augment)` Returns a Score whose value is (this + augment).
`int` | `compareTo(HardMediumSoftScore other)`
`HardMediumSoftScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
`boolean` | `equals(Object o)`
`int` | `getHardScore()` The total of the broken negative hard constraints and fulfilled positive hard constraints.
`int` | `getMediumScore()` The total of the broken negative medium constraints and fulfilled positive medium constraints.
`int` | `getSoftScore()` The total of the broken negative soft constraints and fulfilled positive soft constraints.
`int` | `hashCode()`
`boolean` | `isFeasible()` A `Solution` is feasible if it has no broken hard constraints.
`HardMediumSoftScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
`HardMediumSoftScore` | `negate()` Returns a Score whose value is (- this).
`static HardMediumSoftScore` | `parseScore(String scoreString)`
`HardMediumSoftScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
`HardMediumSoftScore` | `subtract(HardMediumSoftScore subtrahend)` Returns a Score whose value is (this - subtrahend).
`Number[]` | `toLevelNumbers()` Returns an array of numbers representing the Score.
`String` | `toString()`
`static HardMediumSoftScore` | `valueOf(int hardScore, int mediumScore, int softScore)`

Methods inherited from class org.optaplanner.core.api.score.AbstractScore
`buildScorePattern, buildScorePattern, isCompatibleArithmeticArgument, parseLevelAsBigDecimal, parseLevelAsDouble, parseLevelAsInt, parseLevelAsLong, parseLevelStrings, parseLevelStrings`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.api.score.Score
`isCompatibleArithmeticArgument`

Method Detail

### parseScore

    public static HardMediumSoftScore parseScore(String scoreString)

### valueOf

    public static HardMediumSoftScore valueOf(int hardScore,
                                              int mediumScore,
                                              int softScore)

### getHardScore

    public int getHardScore()

  The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.

  Returns:
    higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

### getMediumScore

    public int getMediumScore()

  The total of the broken negative medium constraints and fulfilled positive medium constraints. Their weight is included in the total. The medium score is usually a negative number because most use cases only have negative constraints.

  In a normal score comparison, the medium score is irrelevant if the 2 scores don't have the same score.

  Returns:
    higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

### getSoftScore

    public int getSoftScore()

  The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

  In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard and medium score.

  Returns:
    higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

### isFeasible

    public boolean isFeasible()

  A `Solution` is feasible if it has no broken hard constraints.

  Specified by:
    `isFeasible` in interface `FeasibilityScore<HardMediumSoftScore>`
  Returns:
    true if the `getHardScore()` is 0 or higher

### add

    public HardMediumSoftScore add(HardMediumSoftScore augment)

  Description copied from interface: `Score`
  Returns a Score whose value is (this + augment).

  Specified by:
    `add` in interface `Score<HardMediumSoftScore>`
  Parameters:
    `augment` - value to be added to this Score
  Returns:
    this + augment

### subtract

    public HardMediumSoftScore subtract(HardMediumSoftScore subtrahend)

  Description copied from interface: `Score`
  Returns a Score whose value is (this - subtrahend).

  Specified by:
    `subtract` in interface `Score<HardMediumSoftScore>`
  Parameters:
    `subtrahend` - value to be subtracted from this Score
  Returns:
    this - subtrahend, rounded as necessary

### multiply

    public HardMediumSoftScore multiply(double multiplicand)

  Description copied from interface: `Score`
  Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

  Specified by:
    `multiply` in interface `Score<HardMediumSoftScore>`
  Parameters:
    `multiplicand` - value to be multiplied by this Score.
  Returns:
    this * multiplicand

### divide

    public HardMediumSoftScore divide(double divisor)

  Description copied from interface: `Score`
  Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

  Specified by:
    `divide` in interface `Score<HardMediumSoftScore>`
  Parameters:
    `divisor` - value by which this Score is to be divided
  Returns:
    this / divisor

### power

    public HardMediumSoftScore power(double exponent)

  Description copied from interface: `Score`
  Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

  Specified by:
    `power` in interface `Score<HardMediumSoftScore>`
  Parameters:
    `exponent` - value by which this Score is to be powered
  Returns:
    this ^ exponent

### negate

    public HardMediumSoftScore negate()

  Description copied from interface: `Score`
  Returns a Score whose value is (- this).

  Specified by:
    `negate` in interface `Score<HardMediumSoftScore>`
  Returns:
    - this

### toLevelNumbers

    public Number[] toLevelNumbers()

  Description copied from interface: `Score`
  Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

  When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`. The length of the returned array must be stable for a specific `Score` implementation.

  For example: -0hard/-7soft returns new int{-0, -7}

  Specified by:
    `toLevelNumbers` in interface `Score<HardMediumSoftScore>`
  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(HardMediumSoftScore other)

  Specified by:
    `compareTo` in interface `Comparable<HardMediumSoftScore>`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.